# DataStructures::Table Class Reference

Holds a set of columns, a set of rows, and rows times columns cells. More...

`#include <DS_Table.h>`

List of all members.

## Classes
struct | Cell
| Holds the actual data in the table. More...
struct | ColumnDescriptor
struct | Row
| Stores the list of cells for this row, and a special flag used for internal sorting. More...
## Public Types
enum | SortQueryType
| Increasing or decreasing sort order.
## Public Member Functions
unsigned | AddColumn (const char columnName[_TABLE_MAX_COLUMN_NAME_LENGTH], ColumnType columnType)
| Adds a column to the table.
void | RemoveColumn (unsigned columnIndex)
| Removes a column by index.
unsigned | ColumnIndex (char columnName[_TABLE_MAX_COLUMN_NAME_LENGTH]) const
| Gets the index of a column by name.
char * | ColumnName (unsigned index) const
| Gives the string name of the column at a certain index.
ColumnType | GetColumnType (unsigned index) const
| Returns the type of a column, referenced by index.
unsigned | GetColumnCount (void) const
unsigned | GetRowCount (void) const
Table::Row * | AddRow (unsigned rowId)
| Adds a row to the table.
bool | RemoveRow (unsigned rowId)
| Removes a row specified by rowId.
void | RemoveRows (Table *tableContainingRowIDs)
| Removes all the rows with IDs that the specified table also has.
bool | UpdateCell (unsigned rowId, unsigned columnIndex, int value)
| Updates a particular cell in the table.
void | GetCellValueByIndex (unsigned rowIndex, unsigned columnIndex, int *output)
| Note this is much less efficient to call than GetRow, then working with the cells directly. Numeric, string, binary.
Row * | GetRowByID (unsigned rowId) const
| Gets a row. More efficient to do this and access Row::cells than to repeatedly call GetCell. You can also update cells in rows from this function.
Row * | GetRowByIndex (unsigned rowIndex, unsigned *key) const
| Gets a row at a specific index. rowIndex should be less than GetRowCount().
void | QueryTable (unsigned *columnIndicesSubset, unsigned numColumnSubset, FilterQuery *inclusionFilters, unsigned numInclusionFilters, unsigned *rowIds, unsigned numRowIDs, Table *result)
| Queries the table, optionally returning only a subset of columns and rows.
void | SortTable (Table::SortQuery *sortQueries, unsigned numSortQueries, Table::Row **out)
| Sorts the table by rows.
void | Clear (void)
| Frees all memory in the table.
void | PrintColumnHeaders (char *out, int outLength, char columnDelineator) const
| Prints out the names of all the columns.
void | PrintRow (char *out, int outLength, char columnDelineator, bool printDelineatorForBinary, Table::Row *inputRow) const
| Writes a text representation of the row to out.
const DataStructures::List < ColumnDescriptor > & | GetColumns (void) const
| Direct access to make things easier.
const DataStructures::BPlusTree < unsigned, Row *, _TABLE_BPLUS_TREE_ORDER > & | GetRows (void) const
| Direct access to make things easier.
DataStructures::Page< unsigned, DataStructures::Table::Row *, _TABLE_BPLUS_TREE_ORDER > * | GetListHead (void)
| Get the head of a linked list containing all the row data.
unsigned | GetAvailableRowId (void) const
| Get the first free row id. This could be made more efficient.

## Detailed Description

Holds a set of columns, a set of rows, and rows times columns cells.

The table data structure is useful if you want to store a set of structures and perform queries on those structures.
This is a relatively simple and fast implementation of the types of tables commonly used in databases.
See TableSerializer to serialize data members of the table.
See LightweightDatabaseClient and LightweightDatabaseServer to transmit the table over the network.

## Member Function Documentation

unsigned DataStructures::Table::AddColumn | ( | const char | columnName[_TABLE_MAX_COLUMN_NAME_LENGTH],
|  | ColumnType | columnType |
| ) |  |  |

Adds a column to the table.

Parameters:

  `[in]` | columnName | The name of the column
  `[in]` | columnType | What type of data this column will hold

Returns:
  The index of the new column

Table::Row* DataStructures::Table::AddRow | ( | unsigned | rowId | ) |

Adds a row to the table.

New rows are added with empty values for all cells. However, if you specify initialCelLValues you can specify initial values It's up to you to ensure that the values in the specific cells match the type of data used by that row rowId can be considered the primary key for the row. It is much faster to lookup a row by its rowId than by searching keys. rowId must be unique Rows are stored in sorted order in the table, using rowId as the sort key

Parameters:

  `[in]` | rowId | The UNIQUE primary key for the row. This can never be changed.
  `[in]` | initialCellValues | Initial values to give the row (optional)

Returns:
  The newly added row

unsigned DataStructures::Table::ColumnIndex | ( | char | columnName[_TABLE_MAX_COLUMN_NAME_LENGTH] | ) | const

Gets the index of a column by name.

Column indices are stored in the order they are added.

Parameters:

  `[in]` | columnName | The name of the column

Returns:
  The index of the column, or (unsigned)-1 if no such column

char* DataStructures::Table::ColumnName | ( | unsigned | index | ) | const

Gives the string name of the column at a certain index.

Parameters:

  `[in]` | index | The index of the column

Returns:
  The name of the column, or 0 if an invalid index

unsigned DataStructures::Table::GetColumnCount | ( | void |  | ) | const

Returns the number of columns

Returns:
  The number of columns in the table

ColumnType DataStructures::Table::GetColumnType | ( | unsigned | index | ) | const

Returns the type of a column, referenced by index.

Parameters:

  `[in]` | index | The index of the column

Returns:
  The type of the column

Row* DataStructures::Table::GetRowByID | ( | unsigned | rowId | ) | const

Gets a row. More efficient to do this and access Row::cells than to repeatedly call GetCell. You can also update cells in rows from this function.

Parameters:

  `[in]` | rowId | The ID of the row

Returns:
  The desired row, or 0 if no such row.

Row* DataStructures::Table::GetRowByIndex | ( | unsigned | rowIndex,
|  | unsigned * | key |
| ) |  |  | const

Gets a row at a specific index. rowIndex should be less than GetRowCount().

Parameters:

  `[in]` | rowIndex | The index of the row
  `[out]` | key | The ID of the row returned

Returns:
  The desired row, or 0 if no such row.

unsigned DataStructures::Table::GetRowCount | ( | void |  | ) | const

Returns the number of rows

Returns:
  The number of rows in the table

void DataStructures::Table::PrintColumnHeaders | ( | char * | out,
|  | int | outLength,
|  | char | columnDelineator |
| ) |  |  | const

Prints out the names of all the columns.

Parameters:

  `[out]` | out | A pointer to an array of bytes which will hold the output.
  `[in]` | outLength | The size of the out array
  `[in]` | columnDelineator | What character to print to delineate columns

void DataStructures::Table::PrintRow | ( | char * | out,
|  | int | outLength,
|  | char | columnDelineator,
|  | bool | printDelineatorForBinary,
|  | Table::Row * | inputRow |
| ) |  |  | const

Writes a text representation of the row to out.

Parameters:

  `[out]` | out | A pointer to an array of bytes which will hold the output.
  `[in]` | outLength | The size of the out array
  `[in]` | columnDelineator | What character to print to delineate columns
  `[in]` | printDelineatorForBinary | Binary output is not printed. True to still print the delineator.
  `[in]` | inputRow | The row to print

void DataStructures::Table::QueryTable | ( | unsigned * | columnIndicesSubset,
|  | unsigned | numColumnSubset,
|  | FilterQuery * | inclusionFilters,
|  | unsigned | numInclusionFilters,
|  | unsigned * | rowIds,
|  | unsigned | numRowIDs,
|  | Table * | result |
| ) |  |  |

Queries the table, optionally returning only a subset of columns and rows.

Parameters:

  `[in]` | columnSubset | An array of column indices. Only columns in this array are returned. Pass 0 for all columns
  `[in]` | numColumnSubset | The number of elements in columnSubset
  `[in]` | inclusionFilters | An array of FilterQuery. All filters must pass for the row to be returned.
  `[in]` | numInclusionFilters | The number of elements in inclusionFilters
  `[in]` | rowIds | An arrow of row IDs. Only these rows with these IDs are returned. Pass 0 for all rows.
  `[in]` | numRowIDs | The number of elements in rowIds
  `[out]` | result | The result of the query. If no rows are returned, the table will only have columns.

void DataStructures::Table::RemoveColumn | ( | unsigned | columnIndex | ) |

Removes a column by index.

Parameters:

  `[in]` | columnIndex | The index of the column to remove

bool DataStructures::Table::RemoveRow | ( | unsigned | rowId | ) |

Removes a row specified by rowId.

Parameters:

  `[in]` | rowId | The ID of the row

Returns:
  true if the row was deleted. False if not.

void DataStructures::Table::RemoveRows | ( | Table * | tableContainingRowIDs | ) |

Removes all the rows with IDs that the specified table also has.

Parameters:

  `[in]` | tableContainingRowIDs | The IDs of the rows

void DataStructures::Table::SortTable | ( | Table::SortQuery * | sortQueries,
|  | unsigned | numSortQueries,
|  | Table::Row ** | out |
| ) |  |  |

Sorts the table by rows.

You can sort the table in ascending or descending order on one or more columns Columns have precedence in the order they appear in the sortQueries array If a row cell on column n has the same value as a a different row on column n, then the row will be compared on column n+1

Parameters:

  `[in]` | sortQueries | A list of SortQuery structures, defining the sorts to perform on the table
  `[in]` | numColumnSubset | The number of elements in numSortQueries
  `[out]` | out | The address of an array of Rows, which will receive the sorted output. The array must be long enough to contain all returned rows, up to GetRowCount()

bool DataStructures::Table::UpdateCell | ( | unsigned | rowId,
|  | unsigned | columnIndex,
|  | int | value |
| ) |  |  |

Updates a particular cell in the table.

Note:
  If you are going to update many cells of a particular row, it is more efficient to call GetRow and perform the operations on the row directly.

  Row pointers do not change, so you can also write directly to the rows for more efficiency.

Parameters:

  `[in]` | rowId | The ID of the row
  `[in]` | columnIndex | The column of the cell
  `[in]` | value | The data to set

The documentation for this class was generated from the following file:

- d:/RakNet-3.x/Source/DS_Table.h